## chromium 72.0.3626.7

=== tools/clang/blink_gc_plugin/CMakeLists.txt ===
set(LIBRARYNAME BlinkGCPlugin)

set(plugin_sources
  BadPatternFinder.cpp
  BlinkGCPlugin.cpp
  BlinkGCPluginConsumer.cpp
  CheckDispatchVisitor.cpp
  CheckFieldsVisitor.cpp
  CheckFinalizerVisitor.cpp
  CheckGCRootsVisitor.cpp
  CheckTraceVisitor.cpp
  CollectVisitor.cpp
  Config.cpp
  DiagnosticsReporter.cpp
  Edge.cpp
  RecordInfo.cpp)

if(WIN32)
  # Clang doesn't support loadable modules on Windows. Unfortunately, building
  # the plugin as a static library and linking clang against it doesn't work.
  # Since clang doesn't reference any symbols in our static library, the linker
  # strips it out completely.
  # Instead, we rely on the fact that the SOURCES property of a target is no
  # read-only after CMake 3.1 and use it to compile the plugin directly into
  # clang...
  cmake_minimum_required(VERSION 3.1)
  # Paths must be absolute, since we're modifying a target in another directory.
  set(absolute_sources "")
  foreach(source ${plugin_sources})
    list(APPEND absolute_sources ${CMAKE_CURRENT_SOURCE_DIR}/${source})
  endforeach()
  set_property(TARGET clang APPEND PROPERTY SOURCES ${absolute_sources})

  cr_add_test(blink_gc_plugin_test
    python tests/test.py
    ${CMAKE_BINARY_DIR}/bin/clang
    )
else()
  add_llvm_loadable_module("lib${LIBRARYNAME}" ${plugin_sources})
  add_dependencies("lib${LIBRARYNAME}" clang)

  cr_install(TARGETS "lib${LIBRARYNAME}" LIBRARY DESTINATION lib)

  cr_add_test(blink_gc_plugin_test
    python tests/test.py
    ${CMAKE_BINARY_DIR}/bin/clang
    $<TARGET_FILE:lib${LIBRARYNAME}>
    )
endif()

=== debian/changelog ===
chromium (72.0.3626.7-4) unstable; urgency=medium

  * Reenable support for widevine (closes: #916058).
  * Update maintainer to chromium@packages.debian.org (closes: #915988).

 -- Michael Gilbert <mgilbert@debian.org>  Mon, 24 Dec 2018 19:41:02 +0000

chromium (72.0.3626.7-3) unstable; urgency=medium

  * Remove unintended extra brace in arm patch.

 -- Michael Gilbert <mgilbert@debian.org>  Sun, 16 Dec 2018 22:37:19 +0000

chromium (72.0.3626.7-2) experimental; urgency=medium

  * Fix build failures on arm.

 -- Michael Gilbert <mgilbert@debian.org>  Fri, 14 Dec 2018 02:50:58 +0000

chromium (72.0.3626.7-1) experimental; urgency=medium

  * New upstream developmental release.

 -- Michael Gilbert <mgilbert@debian.org>  Tue, 11 Dec 2018 03:31:15 +0000

chromium (71.0.3578.80-1) unstable; urgency=medium

  * New upstream stable release.
    - CVE-2018-17480: Out of bounds write in V8. Reported by Guang Gong
    - CVE-2018-17481: Use after frees in PDFium. Reported by Anonymous
    - CVE-2018-18335: Heap buffer overflow in Skia. Reported by Anonymous
    - CVE-2018-18336: Use after free in PDFium. Reported by Huyna
    - CVE-2018-18337: Use after free in Blink. Reported by cloudfuzzer
    - CVE-2018-18338: Heap buffer overflow in Canvas. Reported by Zhe Jin
    - CVE-2018-18339: Use after free in WebAudio. Reported by cloudfuzzer
    - CVE-2018-18340: Use after free in MediaRecorder. Reported by Anonymous
    - CVE-2018-18341: Heap buffer overflow in Blink. Reported by cloudfuzzer
    - CVE-2018-18342: Out of bounds write in V8. Reported by Guang Gong
    - CVE-2018-18343: Use after free in Skia. Reported by Tran Tien Hung
    - CVE-2018-18344: Inappropriate implementation in Extensions. Reported by
      Jann Horn
    - CVE-2018-18345: Inappropriate implementation in Site Isolation. Reported
      by Masato Kinugawa and Jun Kokatsu
    - CVE-2018-18346: Incorrect security UI in Blink. Reported by Luan Herrera
    - CVE-2018-18347: Inappropriate implementation in Navigation. Reported by
      Luan Herrera
    - CVE-2018-18348: Inappropriate implementation in Omnibox. Reported by
      Ahmed Elsobky
    - CVE-2018-18349: Insufficient policy enforcement in Blink. Reported by
      David Erceg
    - CVE-2018-18350: Insufficient policy enforcement in Blink. Reported by
      Jun Kokatsu
    - CVE-2018-18351: Insufficient policy enforcement in Navigation. Reported
      by Jun Kokatsu
    - CVE-2018-18352: Inappropriate implementation in Media. Reported by Jun
      Kokatsu
    - CVE-2018-18353: Inappropriate implementation in Network Authentication.
      Reported by Wenxu Wu
    - CVE-2018-18354: Insufficient data validation in Shell Integration.
      Reported by Wenxu Wu
    - CVE-2018-18355: Insufficient policy enforcement in URL Formatter.
      Reported by evi1m0
    - CVE-2018-18356: Use after free in Skia. Reported by Tran Tien Hung
    - CVE-2018-18357: Insufficient policy enforcement in URL Formatter.
      Reported by evi1m0
    - CVE-2018-18358: Insufficient policy enforcement in Proxy. Reported by
      Jann Horn
    - CVE-2018-18359: Out of bounds read in V8. Reported by cyrilliu
    - Inappropriate implementation in PDFium. Reported by Salem Faisal
      Elmrayed
    - Use after free in Extensions. Reported by Zhe Jin
    - Inappropriate implementation in Navigation. Reported by Luan Herrera
    - Inappropriate implementation in Navigation. Reported by Jesper van den
      Ende
    - Insufficient policy enforcement in Navigation. Reported by Ryan Pickren
    - Insufficient policy enforcement in URL Formatter. Reported by evi1m0

 -- Michael Gilbert <mgilbert@debian.org>  Wed, 05 Dec 2018 00:45:35 +0000

=== debian/control ===
Source: chromium
Section: web
Priority: optional
Maintainer: Debian Chromium Team <chromium@packages.debian.org>
Uploaders:
 Michael Gilbert <mgilbert@debian.org>, Riku Voipio <riku.voipio@linaro.org>
Vcs-Git: https://salsa.debian.org/chromium-team/chromium.git
Vcs-Browser: https://salsa.debian.org/chromium-team/chromium
Homepage: http://www.chromium.org/Home
Rules-Requires-Root: no
Build-Depends:
 debhelper (>= 11),
 devscripts (>= 2.18.9),
 python3,
 pkg-config,
 ninja-build,
 python-jinja2,
 ca-certificates,
 wget,
 flex,
 yasm,
 xvfb,
 wdiff,
 gperf,
 bison,
 valgrind,
 xz-utils,
 x11-apps,
 xfonts-base,
 libglewmx-dev,
 libgl1-mesa-dev,
 libglu1-mesa-dev,
 libegl1-mesa-dev,
 libgles2-mesa-dev,
 mesa-common-dev,
 libxt-dev,
 libre2-dev,
 libgbm-dev,
 libpng-dev,
 libxss-dev,
 libelf-dev,
 libvpx-dev (>= 1.7.0),
 libpci-dev,
 libcap-dev,
 libdrm-dev,
 libicu-dev,
 libffi-dev,
 libkrb5-dev,
 libexif-dev,
 libflac-dev,
 libudev-dev,
 libopus-dev,
 libwebp-dev,
 libxtst-dev,
 libsrtp-dev,
 libjpeg-dev,
 libxml2-dev,
 libgtk-3-dev,
 libxslt1-dev,
 liblcms2-dev,
 libpulse-dev,
 libpam0g-dev,
 libsnappy-dev,
 libavutil-dev,
 libavcodec-dev (>= 7:3.0),
 libavformat-dev,
 libglib2.0-dev,
 libasound2-dev,
 libjsoncpp-dev,
 libspeechd-dev (>= 0.8.4),
 libminizip-dev,
 libhunspell-dev,
 libharfbuzz-dev (>= 2.1.1),
 libusb-1.0-0-dev,
 libopenjp2-7-dev,
 libmodpbase64-dev,
 libnss3-dev (>= 3.12.3),
 libnspr4-dev (>= 2:4.9),
 libcups2-dev (>= 1.5.0),
 libevent-dev (>= 1.4.13),
 libjs-jquery,
 libjs-jquery-flot,
 libgcrypt20-dev,
 fonts-ipafont-gothic,
 fonts-ipafont-mincho,
Standards-Version: 4.2.1

Package: chromium
Architecture: i386 amd64 arm64 armhf
Built-Using: ${Built-Using}
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 chromium-common (= ${binary:Version}),
Recommends:
 chromium-sandbox,
Suggests:
 chromium-l10n,
 chromium-shell,
 chromium-driver,
Provides:
 www-browser,
 gnome-www-browser,
Breaks:
 chromium-lwn4chrome (<= 1.0-2),
 chromium-tt-rss-notifier (<= 0.5.2-2),
Conflicts:
 libnettle4,
 libsecret-1-0 (<< 0.18),
 libgl1-mesa-swx11,
Description: web browser
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains the web browser component.

Package: chromium-l10n
Architecture: all
Section: localization
Depends:
 ${misc:Depends},
 chromium (>= ${source:Version}), chromium (<< ${source:Version}.1~),
Description: web browser - language packs
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains language packages for:
 am, ar, bg, bn, ca, cs, da, de, el, en-GB, es-419, es, et, fi, fil, fr, gu, he,
 hi, hr, hu, id, it, ja, kn, ko, lt, lv, ml, mr, nb, nl, pl, pt-BR, pt-PT,
 ro, ru, sk, sl, sr, sv, sw, ta, te, th, tr, uk, vi, zh-CN, zh-TW

Package: chromium-shell
Architecture: i386 amd64 arm64 armhf
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 chromium-common (= ${binary:Version}),
Breaks:
 chromium (<< ${binary:Version}),
Replaces:
 chromium (<< ${binary:Version}),
Description: web browser - minimal shell
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package provides a minimal version of the chromium user interface
 (the content shell).

Package: chromium-driver
Architecture: i386 amd64 arm64 armhf
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 chromium (= ${binary:Version}),
Description: web browser - WebDriver support
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package provides a bridge between the browser component and the selenium
 automatic webdriver.

Package: chromium-common
Architecture: i386 amd64 arm64 armhf
Depends:
 ${misc:Depends},
 x11-utils,
 xdg-utils,
Recommends:
 upower,
 libu2f-udev,
 libgl1-mesa-dri,
 chromium-sandbox,
 fonts-liberation,
 notification-daemon,
Breaks:
 chromium (<< ${binary:Version}),
Replaces:
 chromium (<< ${binary:Version}),
Description: web browser - common resources used by the chromium packages
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains resources that are in common to different chromium
 packages.

Package: chromium-sandbox
Architecture: i386 amd64 arm64 armhf
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 chromium (<< ${binary:Version}),
Replaces:
 chromium (<< ${binary:Version}),
Description: web browser - setuid security sandbox for chromium
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains the setuid chromium sandbox.

=== debian/rules ===
#!/usr/bin/make -f

# enable verbose build messages
export DH_VERBOSE=1

# enable all build hardening flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# indicate that binary targets do not require root
export DEB_RULES_REQUIRES_ROOT=no

# default to gcc when compiler environment variables are unset
export AR=ar
export NM=nm
export CC?=gcc
export CXX?=g++

# more verbose linker output
export LDFLAGS+=-Wl,--stats

# extra flags to reduce warnings that aren't very useful
export CXXFLAGS+=-Wno-pedantic \
                 -Wno-unused-function \
                 -Wno-unused-variable \
                 -Wno-unused-but-set-variable \
                 -Wno-deprecated-declarations \

# ignore warnings for minor mistakes that are too common
export CXXFLAGS+=-Wno-return-type \
                 -Wno-misleading-indentation \

# ignore warnings that are not supported well until gcc 8
export CXXFLAGS+=-Wno-attributes \
                 -Wno-subobject-linkage \

# ignore warnings due to gcc bug (https://gcc.gnu.org/bugzilla/show_bug.cgi?id=84055)
export CXXFLAGS+=-Wno-ignored-attributes

# ingore new gcc 8 warnings that aren't yet handled upstream
export CXXFLAGS+=-Wno-address \
                 -Wno-dangling-else \
                 -Wno-class-memaccess \
                 -Wno-invalid-offsetof \
                 -Wno-packed-not-aligned \

# disable clang options
defines=is_clang=false clang_use_chrome_plugins=false

# build using system toolchain
defines+=host_toolchain=\"//build/toolchain/linux/unbundle:default\"
defines+=custom_toolchain=\"//build/toolchain/linux/unbundle:default\"

# set the appropriate cpu architecture
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
ifeq (i386,$(DEB_HOST_ARCH))
defines+=host_cpu=\"x86\"
endif
ifeq (amd64,$(DEB_HOST_ARCH))
defines+=host_cpu=\"x64\"
endif
ifeq (arm64,$(DEB_HOST_ARCH))
defines+=host_cpu=\"arm64\"
endif
ifeq (armhf,$(DEB_HOST_ARCH))
defines+=host_cpu=\"arm\" arm_use_neon=false symbol_level=0
endif

# disabled features
defines+=is_debug=false \
         use_allocator=\"none\" \
         use_ozone=false \
         use_sysroot=false \
         use_openh264=false \
         use_kerberos=false \
         use_libjpeg_turbo=true \
         use_custom_libcxx=false \
         use_gnome_keyring=false \
         use_unofficial_version_number=false \
         treat_warnings_as_errors=false \
         remove_webcore_debug_symbols=true \
         optimize_webui=false \
         enable_swiftshader=false \
         enable_nacl=false \
         enable_nacl_nonsfi=false \
         enable_reading_list=false \
         enable_one_click_signin=false \
         enable_hangout_services_extension=false \
         enable_iterator_debugging=false \
         goma_dir=\"\" \
         gold_path=\"\" \
         linux_use_bundled_binutils=false \

# enabled features
defines+=use_gio=true \
         use_gold=true \
         use_pulseaudio=true \
         link_pulseaudio=true \
         enable_widevine=true \
         use_system_zlib=true \
         use_system_lcms2=true \
         use_system_libjpeg=true \
         use_system_freetype=true \
         use_system_harfbuzz=true \
         use_jumbo_build=true \
         jumbo_file_merge_limit=12 \
         concurrent_links=1 \
         optimize_for_size=true \
         proprietary_codecs=true \
         ffmpeg_branding=\"Chrome\" \
         fieldtrial_testing_like_official_build=true \

# some notes about embedded libraries
#  can't use system nss since net/third_party/nss is heavily patched
#  can't use system ots (open text *summarizer*) since that's not google's ots (open text *sanitizer*)

# handle parallel build options
njobs=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
njobs=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# paths to files needed by flot
flotpaths=/usr/share/javascript/jquery/*min.js \
          /usr/share/javascript/jquery-flot/*min.js \

%:
	dh $@

out/Release/gn:
	cp base/numerics/safe_conversions_arm_impl.h base/numerics/safe_math_arm_impl.h tools/gn/base/numerics
	./tools/gn/bootstrap/bootstrap.py --skip-generate-buildfiles -j$(njobs)

override_dh_auto_configure:
	# output compiler information
	$(CXX) --version
	# use system flot
	for file in $(flotpaths); do ln -sf $$file third_party/flot; done
	# use polymer from chromium's top level third_party directory
	ln -sf ../../../../third_party/polymer/v1_0/components-chromium third_party/catapult/third_party/polymer/components
	# put yasm script in the location expected by gn
	ln -sf ../pdfium/third_party/yasm/run_yasm.py third_party/yasm
	# strip out system third_party libraries
	rm -f base/third_party/libevent/BUILD.gn build/config/freetype/freetype.gni
	./debian/scripts/unbundle

override_dh_auto_build-arch: out/Release/gn
	./out/Release/gn gen out/Release --args="$(defines)"
	ninja -j$(njobs) -C out/Release chrome chrome_sandbox content_shell chromedriver
	cp out/Release/chrome out/Release/chromium
	cp out/Release/content_shell out/Release/chromium-shell
	cp out/Release/chrome_sandbox out/Release/chrome-sandbox
	cp out/Release/locales/en-US.pak out/Release/resources
	chmod 4755 out/Release/chrome-sandbox # suid sandbox
	sed -e s/@@PACKAGE@@/chromium/g -e s/@@MENUNAME@@/chromium/g \
	    < chrome/app/resources/manpage.1.in > out/Release/chromium.1

override_dh_auto_build-indep: out/Release/gn
	./out/Release/gn gen out/Release --args="$(defines)"
	ninja -j$(njobs) -C out/Release packed_resources
	rm -f out/Release/locales/en-US.pak

override_dh_auto_install-arch:
	dh_auto_install
	# update launcher script with build information
	sed 's|@BUILD_DIST@|$(shell cat /etc/debian_version)|' \
	    < debian/scripts/chromium > debian/chromium/usr/bin/chromium
	# move icons into /usr/share
	./debian/scripts/icons

override_dh_fixperms:
	dh_fixperms --exclude chrome-sandbox

override_dh_gencontrol:
	dh_gencontrol -- -VBuilt-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W libjs-jquery libjs-jquery-flot)"

override_dh_auto_clean:
	rm -rf out
	find . -name \*.pyc -execdir rm -f {} \;
	dh_auto_clean

###################### upstream source downloading ############################

url=https://gsdview.appspot.com/chromium-browser-official
version=$(shell dpkg-parsechangelog -S Version | sed s/-.*//)
extract=chromium-$(version)
tarfile=$(extract)-lite.tar
tarball=$(tarfile).xz
debvers=../chromium_$(version)
origtxz=$(debvers).orig.tar.xz
removed=$(debvers).files-removed
seconds=$(debvers).seconds

get-orig-source:
	wget -nv --show-progress -c $(url)/$(tarball) -O ../$(tarball)
	cp /usr/share/perl5/Devscripts/MkOrigtargz.pm debian/scripts/mk-origtargz
	patch -p1 < debian/scripts/mk-origtargz.patch
	date +%s > $(seconds)
	perl debian/scripts/mk-origtargz ../$(tarball) > $(removed)
	echo $$(($$(date +%s) - $$(cat $(seconds)))) seconds
	test ! -e $(extract) || rm -rf $(extract)
	tar xf ../$(tarball)
	echo $$(($$(date +%s) - $$(cat $(seconds)))) seconds
	while read line; do rm -rf $$line; done < $(removed)
	cd $(extract) && ../debian/scripts/check-upstream
	echo $$(($$(date +%s) - $$(cat $(seconds)))) seconds
	test ! -e $(origtxz) || rm -f $(origtxz)
	tar cf - $(extract) | xz -6 -T $(njobs) - > $(origtxz)
	echo $$(($$(date +%s) - $$(cat $(seconds)))) seconds
	rm -rf $(extract)
	echo $$(($$(date +%s) - $$(cat $(seconds)))) seconds | tee seconds
	@mv -f seconds $(seconds)

## chromium 72.0.3626.96

=== debian/changelog ===
chromium (72.0.3626.96-1~deb9u1) stretch-security; urgency=medium

  * New upstream stable release.
    - CVE-2019-5784: Inappropriate implementation in V8. Reported by Lucas
      Pinheiro

 -- Michael Gilbert <mgilbert@debian.org>  Sat, 16 Feb 2019 17:56:29 +0000

chromium (72.0.3626.81-1~deb9u1) stretch-security; urgency=medium

  * New upstream stable release.
    - Stack buffer overflow in Skia. Reported by Ivan Fratric
    - Use after free in Mojo, FileAPI, and Payments. Reported by Mark Brand
    - CVE-2018-17481: Use after free in PDFium. Reported by Anonymous
    - CVE-2019-5754: Inappropriate implementation in QUIC Networking. Reported
      by Klzgrad
    - CVE-2019-5755: Inappropriate implementation in V8. Reported by Jay
      Bosamiya
    - CVE-2019-5756: Use after free in PDFium. Reported by Anonymous
    - CVE-2019-5757: Type Confusion in SVG. Reported by Alexandru Pitis
    - CVE-2019-5758: Use after free in Blink. Reported by Zhe Jin
    - CVE-2019-5759: Use after free in HTML select elements. Reported by Almog
      Benin
    - CVE-2019-5760: Use after free in WebRTC. Reported by Zhe Jin
    - CVE-2019-5762: Use after free in PDFium. Reported by Anonymous
    - CVE-2019-5763: Insufficient validation of untrusted input in V8.
      Reported by Guang Gong
    - CVE-2019-5764: Use after free in WebRTC. Reported by Eyal Itkin
    - CVE-2019-5765: Insufficient policy enforcement in the browser. Reported
      by Sergey Toshin
    - CVE-2019-5766: Insufficient policy enforcement in Canvas. Reported by
      David Erceg
    - CVE-2019-5767: Incorrect security UI in WebAPKs. Reported by Haoran Lu,
      Yifan Zhang, Luyi Xing, and Xiaojing Liao
    - CVE-2019-5768: Insufficient policy enforcement in DevTools. Reported by
      Rob Wu
    - CVE-2019-5769: Insufficient validation of untrusted input in Blink.
      Reported by Guy Eshel
    - CVE-2019-5770: Heap buffer overflow in WebGL. Reported by hemidallt
    - CVE-2019-5772: Use after free in PDFium. Reported by Zhen Zhou
    - CVE-2019-5773: Insufficient data validation in IndexedDB. Reported by
      Yongke Wang
    - CVE-2019-5774: Insufficient validation of untrusted input in
      SafeBrowsing. Reported by Junghwan Kang and Juno Im
    - CVE-2019-5775: Insufficient policy enforcement in Omnibox. Reported by
      evi1m0
    - CVE-2019-5776: Insufficient policy enforcement in Omnibox. Reported by
      Lnyas Zhang
    - CVE-2019-5777: Insufficient policy enforcement in Omnibox. Reported by
      Khalil Zhani
    - CVE-2019-5778: Insufficient policy enforcement in Extensions. Reported
      by David Erceg
    - CVE-2019-5779: Insufficient policy enforcement in ServiceWorker.
      Reported by David Erceg
    - CVE-2019-5780: Insufficient policy enforcement. Reported by Andreas
      Hegenberg
    - CVE-2019-5781: Insufficient policy enforcement in Omnibox. Reported by
      evi1m0
    - CVE-2019-5782: Inappropriate implementation in V8 reported by Qixun Zhao
    - CVE-2019-5783: Insufficient validation of untrusted input in DevTools.
      Reported by Shintaro Kobori

 -- Michael Gilbert <mgilbert@debian.org>  Thu, 07 Feb 2019 02:41:49 +0000

chromium-browser (71.0.3578.80-1~deb9u1) stretch-security; urgency=medium

  * New upstream stable release.
    - CVE-2018-17480: Out of bounds write in V8. Reported by Guang Gong
    - CVE-2018-17481: Use after frees in PDFium. Reported by Anonymous
    - CVE-2018-18335: Heap buffer overflow in Skia. Reported by Anonymous
    - CVE-2018-18336: Use after free in PDFium. Reported by Huyna
    - CVE-2018-18337: Use after free in Blink. Reported by cloudfuzzer
    - CVE-2018-18338: Heap buffer overflow in Canvas. Reported by Zhe Jin
    - CVE-2018-18339: Use after free in WebAudio. Reported by cloudfuzzer
    - CVE-2018-18340: Use after free in MediaRecorder. Reported by Anonymous
    - CVE-2018-18341: Heap buffer overflow in Blink. Reported by cloudfuzzer
    - CVE-2018-18342: Out of bounds write in V8. Reported by Guang Gong
    - CVE-2018-18343: Use after free in Skia. Reported by Tran Tien Hung
    - CVE-2018-18344: Inappropriate implementation in Extensions. Reported by
      Jann Horn
    - CVE-2018-18345: Inappropriate implementation in Site Isolation. Reported
      by Masato Kinugawa and Jun Kokatsu
    - CVE-2018-18346: Incorrect security UI in Blink. Reported by Luan Herrera
    - CVE-2018-18347: Inappropriate implementation in Navigation. Reported by
      Luan Herrera
    - CVE-2018-18348: Inappropriate implementation in Omnibox. Reported by
      Ahmed Elsobky
    - CVE-2018-18349: Insufficient policy enforcement in Blink. Reported by
      David Erceg
    - CVE-2018-18350: Insufficient policy enforcement in Blink. Reported by
      Jun Kokatsu
    - CVE-2018-18351: Insufficient policy enforcement in Navigation. Reported
      by Jun Kokatsu
    - CVE-2018-18352: Inappropriate implementation in Media. Reported by Jun
      Kokatsu
    - CVE-2018-18353: Inappropriate implementation in Network Authentication.
      Reported by Wenxu Wu
    - CVE-2018-18354: Insufficient data validation in Shell Integration.
      Reported by Wenxu Wu
    - CVE-2018-18355: Insufficient policy enforcement in URL Formatter.
      Reported by evi1m0
    - CVE-2018-18356: Use after free in Skia. Reported by Tran Tien Hung
    - CVE-2018-18357: Insufficient policy enforcement in URL Formatter.
      Reported by evi1m0
    - CVE-2018-18358: Insufficient policy enforcement in Proxy. Reported by
      Jann Horn
    - CVE-2018-18359: Out of bounds read in V8. Reported by cyrilliu
    - Inappropriate implementation in PDFium. Reported by Salem Faisal
      Elmrayed
    - Use after free in Extensions. Reported by Zhe Jin
    - Inappropriate implementation in Navigation. Reported by Luan Herrera
    - Inappropriate implementation in Navigation. Reported by Jesper van den
      Ende
    - Insufficient policy enforcement in Navigation. Reported by Ryan Pickren


=== debian/control ===
Source: chromium
Section: web
Priority: optional
Maintainer: Debian Chromium Maintainers <pkg-chromium-maint@lists.alioth.debian.org>
Uploaders:
 Michael Gilbert <mgilbert@debian.org>, Riku Voipio <riku.voipio@linaro.org>
Vcs-Git: git://anonscm.debian.org/pkg-chromium/pkg-chromium.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-chromium/pkg-chromium.git
Homepage: http://www.chromium.org/Home
Build-Depends:
 debhelper (>= 9),
 python3,
 pkg-config,
 ninja-build,
 python-jinja2,
 ca-certificates,
 wget,
 flex,
 yasm,
 xvfb,
 wdiff,
 gperf,
 bison,
 valgrind,
 xz-utils,
 x11-apps,
 xfonts-base,
 libglewmx-dev,
 libgl1-mesa-dev,
 libglu1-mesa-dev,
 libegl1-mesa-dev,
 libgles2-mesa-dev,
 mesa-common-dev,
 libxt-dev,
 libre2-dev,
 libgbm-dev,
 libpng-dev,
 libxss-dev,
 libelf-dev,
 libvpx-dev,
 libpci-dev,
 libcap-dev,
 libdrm-dev,
 libicu-dev,
 libffi-dev,
 libkrb5-dev,
 libexif-dev,
 libflac-dev,
 libudev-dev,
 libopus-dev,
 libwebp-dev,
 libxtst-dev,
 libsrtp-dev,
 libjpeg-dev,
 libxml2-dev,
 libgtk-3-dev,
 libgtk2.0-dev,
 libxslt1-dev,
 libpulse-dev,
 libpam0g-dev,
 libsnappy-dev,
 libavutil-dev,
 libavcodec-dev (>= 7:3.0),
 libavformat-dev,
 libglib2.0-dev,
 libasound2-dev,
 libsqlite3-dev,
 libjsoncpp-dev,
 libspeechd-dev (>= 0.8.4),
 libminizip-dev,
 libhunspell-dev,
 libharfbuzz-dev (>= 1.2.7),
 libusb-1.0-0-dev,
 libopenjp2-7-dev,
 libmodpbase64-dev,
 libgnome-keyring-dev,
 libnss3-dev (>= 3.12.3),
 libnspr4-dev (>= 2:4.9),
 libcups2-dev (>= 1.5.0),
 libevent-dev (>= 1.4.13),
 libjs-jquery,
 libjs-excanvas,
 libjs-jquery-flot,
 libgcrypt20-dev,
 fonts-ipafont-gothic,
 fonts-ipafont-mincho,
Standards-Version: 3.9.8

Package: chromium
Architecture: i386 amd64 arm64 armhf
Built-Using: ${Built-Using}
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 x11-utils,
 xdg-utils,
Recommends:
 libgl1-mesa-dri,
 fonts-liberation,
Suggests:
 chromium-l10n,
 chromium-shell,
 chromium-driver,
 chromium-widevine,
Provides:
 www-browser,
 gnome-www-browser,
Conflicts:
 libnettle4,
 libsecret-1-0 (<< 0.18),
 libgl1-mesa-swx11,
Breaks:
 chromium-common (<< ${binary:Version}),
Replaces:
 chromium-common (<< ${binary:Version}),
Description: web browser
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains the web browser component.

Package: chromium-l10n
Architecture: all
Section: localization
Depends:
 ${misc:Depends},
 chromium (>= ${source:Version}), chromium (<< ${source:Version}.1~),
Description: web browser - language packs
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains language packages for:
 am, ar, bg, bn, ca, cs, da, de, el, en-GB, es-419, es, et, fi, fil, fr, gu, he,
 hi, hr, hu, id, it, ja, kn, ko, lt, lv, ml, mr, nb, nl, pl, pt-BR, pt-PT,
 ro, ru, sk, sl, sr, sv, sw, ta, te, th, tr, uk, vi, zh-CN, zh-TW

Package: chromium-shell
Architecture: i386 amd64 arm64 armhf
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: web browser - minimal shell
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package provides a minimal version of the chromium user interface
 (the content shell).

Package: chromium-widevine
Section: contrib/web
Architecture: i386 amd64 arm64 armhf
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 chromium (= ${binary:Version}),
Description: web browser - widevine content decryption support
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package provides support for the widevine content decryption module.

Package: chromium-driver
Architecture: i386 amd64 arm64 armhf
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 chromium (= ${binary:Version}),
Description: web browser - WebDriver support
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package provides a bridge between the browser component and the selenium
 automatic webdriver.

Package: chromedriver
Architecture: i386 amd64 arm64 armhf
Depends:
 ${misc:Depends},
 chromium-driver (= ${binary:Version}),
Description: web browser - WebDriver support transitional package
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This is a transitional package and can be safely removed.

## chromium 72.0.3626.109

=== tools/clang/rewrite_scoped_refptr/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  BitReader
  MCParser
  Option
  X86AsmParser
  X86CodeGen
  )

add_llvm_executable(rewrite_scoped_refptr
  RewriteScopedRefptr.cpp
  )

target_link_libraries(rewrite_scoped_refptr
  clangAST
  clangASTMatchers
  clangAnalysis
  clangBasic
  clangDriver
  clangEdit
  clangFrontend
  clangLex
  clangParse
  clangSema
  clangSerialization
  clangTooling
  )

cr_install(TARGETS rewrite_scoped_refptr RUNTIME DESTINATION bin)

=== debian/changelog ===
chromium (72.0.3626.109-1) unstable; urgency=medium

  * New upstream stable release.
    - CVE-2019-5784: Inappropriate implementation in V8. Reported by Lucas
      Pinheiro
  * Build pdfium using system lcms.
  * Renable support for kerberos (closes: #916684).
  * Fix 32-bit type error in the vaapi implementation (closes: #921823).

 -- Michael Gilbert <mgilbert@debian.org>  Mon, 04 Feb 2019 04:27:06 +0000

chromium (72.0.3626.81-1) unstable; urgency=medium

  * New upstream stable release.
    - Stack buffer overflow in Skia. Reported by Ivan Fratric
    - Use after free in Mojo, FileAPI, and Payments. Reported by Mark Brand
    - CVE-2018-17481: Use after free in PDFium. Reported by Anonymous
    - CVE-2019-5754: Inappropriate implementation in QUIC Networking. Reported
      by Klzgrad
    - CVE-2019-5755: Inappropriate implementation in V8. Reported by Jay
      Bosamiya
    - CVE-2019-5756: Use after free in PDFium. Reported by Anonymous
    - CVE-2019-5757: Type Confusion in SVG. Reported by Alexandru Pitis
    - CVE-2019-5758: Use after free in Blink. Reported by Zhe Jin
    - CVE-2019-5759: Use after free in HTML select elements. Reported by Almog
      Benin
    - CVE-2019-5760: Use after free in WebRTC. Reported by Zhe Jin
    - CVE-2019-5762: Use after free in PDFium. Reported by Anonymous
    - CVE-2019-5763: Insufficient validation of untrusted input in V8.
      Reported by Guang Gong
    - CVE-2019-5764: Use after free in WebRTC. Reported by Eyal Itkin
    - CVE-2019-5765: Insufficient policy enforcement in the browser. Reported
      by Sergey Toshin
    - CVE-2019-5766: Insufficient policy enforcement in Canvas. Reported by
      David Erceg
    - CVE-2019-5767: Incorrect security UI in WebAPKs. Reported by Haoran Lu,
      Yifan Zhang, Luyi Xing, and Xiaojing Liao
    - CVE-2019-5768: Insufficient policy enforcement in DevTools. Reported by
      Rob Wu
    - CVE-2019-5769: Insufficient validation of untrusted input in Blink.
      Reported by Guy Eshel
    - CVE-2019-5770: Heap buffer overflow in WebGL. Reported by hemidallt
    - CVE-2019-5772: Use after free in PDFium. Reported by Zhen Zhou
    - CVE-2019-5773: Insufficient data validation in IndexedDB. Reported by
      Yongke Wang
    - CVE-2019-5774: Insufficient validation of untrusted input in
      SafeBrowsing. Reported by Junghwan Kang and Juno Im
    - CVE-2019-5775: Insufficient policy enforcement in Omnibox. Reported by
      evi1m0
    - CVE-2019-5776: Insufficient policy enforcement in Omnibox. Reported by
      Lnyas Zhang
    - CVE-2019-5777: Insufficient policy enforcement in Omnibox. Reported by
      Khalil Zhani
    - CVE-2019-5778: Insufficient policy enforcement in Extensions. Reported
      by David Erceg
    - CVE-2019-5779: Insufficient policy enforcement in ServiceWorker.
      Reported by David Erceg
    - CVE-2019-5780: Insufficient policy enforcement. Reported by Andreas
      Hegenberg
    - CVE-2019-5781: Insufficient policy enforcement in Omnibox. Reported by
      evi1m0
    - CVE-2019-5782: Inappropriate implementation in V8 reported by Qixun Zhao
    - CVE-2019-5783: Insufficient validation of untrusted input in DevTools.
      Reported by Shintaro Kobori
  * Opt out of all Google web service options by default (closes: #916320).
  * Enable support for hardware accelerated video decoding (closes: #856255).
    - Thanks to Akarshan Biswas.

 -- Michael Gilbert <mgilbert@debian.org>  Sat, 02 Feb 2019 05:05:43 +0000

chromium (72.0.3626.53-1) unstable; urgency=medium

  * New upstream beta release.
  * Organize the gcc 6 patches.
  * Update standards version to 4.3.0.
  * Drop libsrtp from the build dependencies (closes: #918542).

 -- Michael Gilbert <mgilbert@debian.org>  Sat, 12 Jan 2019 07:17:20 +0000

chromium (72.0.3626.7-6) unstable; urgency=medium

  * Upload to unstable: fix FTBFS on arm64 and armhf

 -- Riku Voipio <riku.voipio@linaro.org>  Tue, 08 Jan 2019 14:41:13 +0200

chromium (72.0.3626.7-5) experimental; urgency=medium

  * Fix armhf and arm64 builds

 -- Riku Voipio <riku.voipio@linaro.org>  Fri, 04 Jan 2019 16:17:43 +0200

## chromium 72.0.3626.122

=== tools/clang/rewrite_to_chrome_style/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  BitReader
  MCParser
  Option
  X86AsmParser
  X86CodeGen
  )

add_llvm_executable(rewrite_to_chrome_style
  EditTracker.cpp
  RewriteToChromeStyle.cpp
  )

target_link_libraries(rewrite_to_chrome_style
  clangAST
  clangASTMatchers
  clangAnalysis
  clangBasic
  clangDriver
  clangEdit
  clangFrontend
  clangLex
  clangParse
  clangSema
  clangSerialization
  clangTooling
  )

cr_install(TARGETS rewrite_to_chrome_style RUNTIME DESTINATION bin)

=== tools/clang/value_cleanup/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  BitReader
  MCParser
  Option
  X86AsmParser
  X86CodeGen
  )

add_llvm_executable(value_cleanup
  ValueCleanup.cpp
  ValueRewriter.cpp
  )

target_link_libraries(value_cleanup
  clangAST
  clangASTMatchers
  clangAnalysis
  clangBasic
  clangDriver
  clangEdit
  clangFrontend
  clangLex
  clangParse
  clangSema
  clangSerialization
  clangTooling
  )

cr_install(TARGETS value_cleanup RUNTIME DESTINATION bin)

=== debian/changelog ===
chromium (72.0.3626.122-1~deb9u1) stretch-security; urgency=medium

  * New upstream security release.
    - CVE-2019-5786: Use-after-free in FileReader. Reported by Clement Lecigne
  * Fix crash when launched in remote debugging mode (closes: #922794).

 -- Michael Gilbert <mgilbert@debian.org>  Sat, 09 Mar 2019 20:20:25 +0000

chromium (72.0.3626.96-1~deb9u2) stretch-security; urgency=medium

  * Fix crash when launched in headless mode (closes: #922806).
  * Replace files from chromium-sandbox on upgrade (closes: #923298).

 -- Michael Gilbert <mgilbert@debian.org>  Tue, 26 Feb 2019 02:53:04 +0000

=== debian/control ===
--- 
+++ 
@@ -111,8 +111,10 @@
  libgl1-mesa-swx11,
 Breaks:
  chromium-common (<< ${binary:Version}),
+ chromium-sandbox (<< ${binary:Version}),
 Replaces:
  chromium-common (<< ${binary:Version}),
+ chromium-sandbox (<< ${binary:Version}),
 Description: web browser
  Web browser that aims to build a safer, faster, and more stable internet
  browsing experience.

=== debian/rules ===
#!/usr/bin/make -f

# enable verbose build messages
export DH_VERBOSE=1

# enable all build hardening flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# needed to avoid build system choosing clang as the compiler
export CC=gcc
export CXX=g++

# build with gcc instead of clang
defines=is_clang=false clang_use_chrome_plugins=false

# more verbose linker output
export LDFLAGS+=-Wl,--stats

# avoid error in v8's garbage collector (see http://gcc.gnu.org/bugzilla/show_bug.cgi?id=68853)
export CXXFLAGS+=-fno-delete-null-pointer-checks

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# set the appropriate cpu architecture
ifeq (i386,$(DEB_HOST_ARCH))
defines+=host_cpu=\"x86\"
endif
ifeq (amd64,$(DEB_HOST_ARCH))
defines+=host_cpu=\"x64\"
endif
ifeq (arm64,$(DEB_HOST_ARCH))
defines+=host_cpu=\"arm64\"
endif
ifeq (armhf,$(DEB_HOST_ARCH))
defines+=host_cpu=\"arm\" arm_use_neon=false symbol_level=0
endif

# disabled features
defines+=gtk_version=2 \
         is_debug=false \
         use_allocator=\"none\" \
         use_goma=false \
         use_ozone=false \
         use_sysroot=false \
         use_openh264=false \
         use_custom_libcxx=false \
         use_gnome_keyring=false \
         use_system_harfbuzz=false \
         rtc_libvpx_build_vp9=false \
         treat_warnings_as_errors=false \
         remove_webcore_debug_symbols=true \
         optimize_webui=false \
         enable_swiftshader=false \
         enable_nacl=false \
         enable_nacl_nonsfi=false \
         enable_one_click_signin=false \
         enable_hangout_services_extension=false \
         enable_iterator_debugging=false \
         linux_use_bundled_binutils=false \

# enabled features
defines+=use_gio=true \
         use_pulseaudio=true \
         link_pulseaudio=true \
         enable_widevine=true \
         use_libjpeg_turbo=true \
         use_system_libjpeg=true \
         use_system_freetype=true \
         concurrent_links=1 \
         use_jumbo_build=true \
         jumbo_file_merge_limit=8 \
         proprietary_codecs=true \
         ffmpeg_branding=\"Chrome\" \
         fieldtrial_testing_like_official_build=true \

# some notes about embedded libraries
#  can't use system nss since net/third_party/nss is heavily patched
#  can't use system ots (open text *summarizer*) since that's not google's ots (open text *sanitizer*)

# handle parallel build options
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
njobs=-j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# paths to files needed by flot
flotpaths=/usr/share/javascript/jquery/*min.js \
          /usr/share/javascript/jquery-flot/*min.js \

%:
	dh $@ --parallel

override_dh_auto_configure:
	# output compiler information
	$(CXX) --version
	# use system flot
	for file in $(flotpaths); do ln -sf $$file third_party/flot; done
	# put yasm script in the location expected by gn
	ln -sf ../pdfium/third_party/yasm/run_yasm.py third_party/yasm
	# strip out system third_party libraries
	rm -f build/config/freetype/freetype.gni
	mkdir -p base/third_party/libevent
	./debian/scripts/unbundle
	# build gn
	cp base/numerics/safe_conversions_arm_impl.h base/numerics/safe_math_arm_impl.h tools/gn/base/numerics
	./tools/gn/bootstrap/bootstrap.py --skip-generate-buildfiles -s $(njobs)
	# configure
	./out/Release/gn gen out/Release --args="$(defines)"

override_dh_auto_build-arch:
	./out/Release/gn gen out/Release --args="$(defines)"
	ninja $(njobs) -C out/Release chrome chrome_sandbox content_shell chromedriver
	mv out/Release/chrome out/Release/chromium || true
	mv out/Release/content_shell out/Release/chromium-shell || true
	mv out/Release/chrome_sandbox out/Release/chrome-sandbox || true
	mv out/Release/locales/en-US.pak out/Release/resources || true
	chmod 4755 out/Release/chrome-sandbox # suid sandbox
	sed -e s/@@PACKAGE@@/chromium/g -e s/@@MENUNAME@@/chromium/g \
	    < chrome/app/resources/manpage.1.in > out/Release/chromium.1

override_dh_auto_build-indep:
	ninja $(njobs) -C out/Release packed_resources
	rm -f out/Release/locales/en-US.pak

override_dh_auto_install-arch:
	dh_auto_install
	# create /etc/chromium.d README file
	echo "Any files placed in this directory will be sourced prior to executing chromium." \
	    > debian/chromium/etc/chromium.d/README
	# update launcher script with build information
	sed 's|@BUILD_DIST@|$(shell cat /etc/debian_version)|' \
	    < debian/scripts/chromium > debian/chromium/usr/bin/chromium
	# move icons into /usr/share
	for file in $(shell find chrome/app/theme/chromium -name product_logo_[0-9]* -a ! -name *mono*); do \
	    ext=$$(echo $$file | cut -d\. -f2); \
	    siz=$$(echo $$file | cut -d_ -f3 | sed s/\.$$ext//); \
	    dst=debian/chromium/usr/share/icons/hicolor/$$siz\x$$siz/apps; \
	    mkdir -p $$dst; \
	    cp $$file $$dst/chromium.$$ext; \
	    done

override_dh_fixperms:
	dh_fixperms --exclude chrome-sandbox

override_dh_strip:
	# this line can be removed once stretch is released
	dh_strip --remaining-packages --ddeb-migration='chromium-dbg (<< 47.0.2526.80-4~)'

override_dh_gencontrol:
	dh_gencontrol -- -VBuilt-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W libjs-jquery libjs-jquery-flot)"

override_dh_auto_clean:
	rm -rf out
	find . -name \*.pyc -execdir rm -f {} \;
	dh_auto_clean

###################### upstream source downloading ############################

url=https://gsdview.appspot.com/chromium-browser-official
version=$(shell dpkg-parsechangelog -S Version | sed s/-.*//)
tarball=chromium-$(version).tar.xz
removed=chromium-browser_$(version).files-removed

get-orig-source:
	wget -nv --show-progress -c $(url)/$(tarball) -O ../$(tarball)
	mk-origtargz ../$(tarball) | tee ../$(removed)
	echo >> ../$(removed)
	tar tf ../$(tarball) | sort > ../chromium.upstream
	tar tf ../chromium-browser_$(version).orig.tar.xz | sort > ../chromium.orig
	diff -u ../chromium.upstream ../chromium.orig >> ../$(removed) || true
